using System;
using System.Collections.Generic;
using System.Text;
using CRFractal;
using System.Drawing;



namespace FractalAnimator
{
    class FractalAnimatorAbstract
    {
        AviWriter mAviWriter;
        AnimationTransitionHolder mTransitions;
        RFractal                            mFractal;
        public FractalAnimatorAbstract()
        {

           

             mFractal = new RFractal();
             mTransitions = new AnimationTransitionHolder();
             mFractal.SetFormula("ZPower");
             Init();
             CreateAviAnimation();
        }

        public void Init() 
        {
            PositionFractalAnimator NPosition;

            NPosition = new PositionFractalAnimator();

            NPosition.Center.X = 0;
            NPosition.Center.Y = 0;

            NPosition.Size.X = 2;
            NPosition.Size.Y = 1;

            NPosition.Zoom = 1;

            NPosition.Frame = 0;

            mTransitions.AddAnimationPoint(NPosition);
            NPosition.Zoom = 0.1;
            NPosition.Frame = 10;
            NPosition.Center.X = -1.3;
            mTransitions.AddAnimationPoint(NPosition);
            NPosition.Zoom = 0.01;
            NPosition.Frame = 30;
            NPosition.Center.X = -1.45;
            mTransitions.AddAnimationPoint(NPosition);

            NPosition.Zoom = 0.001;
            NPosition.Frame = 70;
            NPosition.Center.X = -1.45;
            mTransitions.AddAnimationPoint(NPosition);

            NPosition.Zoom = 0.0001;
            NPosition.Frame = 140;
            NPosition.Center.X = -1.45002;
            mTransitions.AddAnimationPoint(NPosition);

        }

        public void CreateAviAnimation()
        {
            int w = 400;
            int h = 400;

            mAviWriter = new AviWriter();
            Bitmap bmp = mAviWriter.Open("test.avi", 25, w, h);
            Graphics g = Graphics.FromImage(bmp);
            mTransitions.ResetAnimator();

                PositionFractalAnimator mAnimPosition;
                mAnimPosition  = new PositionFractalAnimator();
                while (mTransitions.GetNextFrame(out mAnimPosition))
                {
//                    mFractal.InputGrid.Area = mAnimPosition.GetArea();
                    mFractal.SetInutArea(mAnimPosition.GetArea());

               //     mFractal.Mandelbrot.

                  mFractal.Calculate();
//                  mFractal.Mandelbrot.DrawImage(g);
                  mFractal.Mandelbrot.DrawImage(g);
                    mAviWriter.AddFrame();
                }
                mAviWriter.Close();
            }
    }
}

