using System;
using System.Collections.Generic;
using System.Text;

using RakabrotPluginInterface.RCommon;
namespace FractalAnimator
{
    class PositionFractalAnimator
    {
        public RVector Center;
        public RVector Size;
        public double  Zoom;
        public int     Frame;

        public PositionFractalAnimator()
        {
            Center = new RVector(0, 0);
            Size = new RVector(0, 0);
            Zoom = 1;
            Frame = 0;
        }

        public RArea GetArea(){

            return new RArea(Center.X - Size.X * Zoom, Center.Y - Size.Y * Zoom,
                             Center.X + Size.X * Zoom, Center.Y + Size.Y * Zoom);
        } 

    }

    class TransitionFractalAnimator
    {
        PositionFractalAnimator mStart;
        PositionFractalAnimator mEnd;

        int                     NumberOfFrames;
        int                     ActiveFrame;

//        RVector                 StepSize;
//        RVector                 StepCenter;
        
        public bool GetNextFrame(out PositionFractalAnimator NewPosition)
        {
        PositionFractalAnimator Result;


        NewPosition = new PositionFractalAnimator();

        NewPosition.Size.Set(mStart.Size + ((mEnd.Size - mStart.Size) * ((double)ActiveFrame / (double)NumberOfFrames)));
        NewPosition.Center.Set(mStart.Center + ((mEnd.Center - mStart.Center) * ((double)ActiveFrame / (double)NumberOfFrames)));
        NewPosition.Zoom = mStart.Zoom +( (mEnd.Zoom - mStart.Zoom) * ((double)ActiveFrame / (double)NumberOfFrames));


        ActiveFrame++;
        if(ActiveFrame< NumberOfFrames)
                    return true;
        else
                    return false;
            }

        public void Reset()
        {
            ActiveFrame = 0;
        }

        public void Setup(PositionFractalAnimator nStart, PositionFractalAnimator nEnd)
        {
            mStart = nStart;
            mEnd = nEnd;

            NumberOfFrames = mEnd.Frame - mStart.Frame + 1;
            ActiveFrame = 0;

        }

    }


}
