


using System;
using System.Collections.Generic;
using System.Text;


    
namespace FractalAnimator 
{
    class AnimationTransitionHolder
    {
        public  const int MaxAnimationPositions  = 100;

        PositionFractalAnimator[] mAnimationPositions;
        int                                   mMaxIndex;
        int                                   mCurrentIndex;
        TransitionFractalAnimator mTransition;


        public AnimationTransitionHolder()
        {
            mAnimationPositions = new PositionFractalAnimator[MaxAnimationPositions];
            mMaxIndex     = 0;
            mCurrentIndex = 0;
            mTransition = new TransitionFractalAnimator();
        }

        public void AddAnimationPoint(PositionFractalAnimator nAnimationPosition)
        {
            if(mMaxIndex <MaxAnimationPositions)
            {

                mAnimationPositions[mMaxIndex] = new PositionFractalAnimator();
                mAnimationPositions[mMaxIndex].Center.Set(nAnimationPosition.Center);
                mAnimationPositions[mMaxIndex].Size.Set(nAnimationPosition.Size);
                mAnimationPositions[mMaxIndex].Zoom = nAnimationPosition.Zoom;
                mAnimationPositions[mMaxIndex].Frame = nAnimationPosition.Frame;
                mMaxIndex++; 
            }
        }

        public void EmptyAnimator()
        {
            mMaxIndex = 0;
        }
        public void ResetAnimator()
        {
            mCurrentIndex = 0;
            SetAnimationTransition(0);
        }
        public void SetAnimationTransition(int i)
        {

            mTransition.Setup(mAnimationPositions[i], mAnimationPositions[i + 1]);
        }

        public bool GetNextFrame(out PositionFractalAnimator NewPosition)
        {
            if (!mTransition.GetNextFrame(out NewPosition)) 
            {
                mCurrentIndex++;
                if (mCurrentIndex < mMaxIndex-1)
                {
                    SetAnimationTransition(mCurrentIndex);
                    return true;
                }
                else
                    return false;
            }
            return true;
        }
    }
}
