using System;
using System.IO;

namespace RakabrotPluginInterface
{
    namespace RCommon
    {
        /// <summary>
        /// 
        /// </summary>
        public class RArea
        {
            RVector TopLeft;
            RVector BottomRight;
            public RArea()
            {
                // 
                // TODO: Add constructor logic here
                //
                TopLeft = new RVector(-2, -1);
                BottomRight = new RVector(1, 1);
            }

            public void SetTopLeft(RVector nTopLeft)
            {
                TopLeft = nTopLeft;
            }
            public RVector GetTopLeft()
            {
                return TopLeft;
            }
            public RVector GetBottomRight()
            {
                return BottomRight;
            }
            public void SetBottomRight(RVector nBottomRight)
            {
                BottomRight = nBottomRight;
            }
            public RArea(double Left, double Top, double Right, double Bottom)
            {
                // 
                // TODO: Add constructor logic here
                //
                TopLeft = new RVector(Left, Top);
                BottomRight = new RVector(Right, Bottom);
            }
            public RArea(RVector nTopLeft, RVector nBottomRight)
            {
                // 
                // TODO: Add constructor logic here
                //
                TopLeft = nTopLeft;
                BottomRight = nBottomRight;
            }

            public double Top
            {
                get
                {
                    return TopLeft.Y;
                }
                set
                {
                    TopLeft.Y = value;
                }
            }

            public double Left
            {
                get
                {
                    return TopLeft.X;
                }
                set
                {
                    TopLeft.X = value;
                }
            }

            public double Right
            {
                get
                {
                    return BottomRight.X;
                }
                set
                {
                    BottomRight.X = value;
                }
            }

            public double Bottom
            {
                get
                {
                    return BottomRight.Y;
                }
                set
                {
                    BottomRight.Y = value;
                }
            }
            public virtual void SaveToFile(StreamWriter sw, string ExtraInfo)
            {
                TopLeft.SaveToFile(sw, ExtraInfo + "TopLeft");
                BottomRight.SaveToFile(sw, ExtraInfo + "BottomRight");
            }

            public virtual void LoadFromFile(StreamReader sr)
            {
                TopLeft.LoadFromFile(sr);
                BottomRight.LoadFromFile(sr);

            }

            public double Width
            {
                get
                {
                    return BottomRight.X - TopLeft.X;
                }
            }

            public double Height
            {
                get
                {
                    return BottomRight.Y - TopLeft.Y;
                }
            }

            public void Copy(RArea nArea)
            {
                TopLeft.X = nArea.Left;
                TopLeft.Y = nArea.Top;
                BottomRight.X = nArea.Right;
                BottomRight.Y = nArea.Bottom;

            }

            public virtual bool Inside(double X, double Y)
            {
                return (X > Left) && (X < Right) &&
                    (Y > Top) && (Y < Bottom);
            }

        }
        /// <summary>
        /// 
        /// </summary>
        public class RGrid
        {
            int mWidth;
            int mHeight;
            public RGrid()
            {
                // 
                // TODO: Add constructor logic here
                //
                mWidth = 300;
                mHeight = 200;
            }

            public int Width
            {
                get
                {
                    return mWidth;
                }
                set
                {
                    mWidth = value;
                }
            }

            public int Height
            {
                get
                {
                    return mHeight;
                }
                set
                {
                    mHeight = value;
                }
            }

            public void SaveToFile(StreamWriter sw, string ExtraInfo)
            {
                sw.WriteLine(ExtraInfo + " Width:");
                sw.WriteLine(mWidth);
                sw.WriteLine(ExtraInfo + "Height:");
                sw.WriteLine(mHeight);

            }

            public void LoadFromFile(StreamReader sr)
            {
                String Line;

                Line = sr.ReadLine();
                Line = sr.ReadLine();
                mWidth = System.Convert.ToInt32(Line);

                Line = sr.ReadLine();
                Line = sr.ReadLine();
                mHeight = System.Convert.ToInt32(Line);

            }

            public void Copy(RGrid nGrid)
            {
                Height = nGrid.Height;
                Width = nGrid.Width;

            }


        }
    }
}