using System;
using System.IO;

namespace RakabrotPluginInterface
{
    namespace RCommon
    {
        /// <summary>
        /// 
        /// </summary>
        public class RAreaOptimizationArray
        {
            RAreaOptimization[] mArray;
            int mMaxIndex;
            int mSize;
            int mActive;
            public RAreaOptimizationArray()
            {
                // 
                // TODO: Add constructor logic here
                //
                mMaxIndex = 0;
                mSize = 0;
                mActive = 0;
            }
            public RAreaOptimizationArray(int nSize)
            {
                // 
                // TODO: Add constructor logic here
                //
                mSize = nSize;
                mArray = new RAreaOptimization[mSize];
                mMaxIndex = 0;
                mActive = 0;

            }

            public RArea this[int i]
            {
                get
                {
                    return mArray[i];
                }
                set
                {
                    mArray[i].Copy(value);
                }
            }
            public int Inside(double X, double Y)
            {
                for (int i = 0; i < mMaxIndex; i++)
                {
                    if (mArray[i].Inside(X, Y))
                        return i;
                }
                return -1;
            }
            public bool AddArea()
            {
                if (mMaxIndex >= mSize)
                    return false;
                mArray[mMaxIndex] = new RAreaOptimization();
                mActive = mMaxIndex;
                mMaxIndex++;
                return true;
            }
            public void DeleteArea(int Index)
            {
                if ((Index < 0) || Index >= mMaxIndex)
                    return;


                if (mActive == Index)
                    mActive = 0;

                mArray[Index] = null;
                for (int i = Index; i < mMaxIndex - 1; i++)
                {
                    mArray[i] = mArray[i + 1];
                }
                mArray[mMaxIndex] = null;
                mMaxIndex--;
            }

            public int Active
            {
                get
                {
                    return mActive;
                }
                set
                {
                    mActive = value;
                }
            }
            public RAreaOptimization GetActive()
            {
                return mArray[mActive];
            }
            public void DeleteActive()
            {
                DeleteArea(mActive);
            }
            public int GetMaxIndex()
            {
                return mMaxIndex;
            }
            public void LoadFromFile(StreamReader sr)
            {
                String Line;
                Line = sr.ReadLine();
                Line = sr.ReadLine();
                mMaxIndex = System.Convert.ToInt32(Line);
                for (int i = 0; i < mMaxIndex; i++)
                {
                    mArray[i] = new RAreaOptimization();
                    mArray[i].LoadFromFile(sr);

                }
            }

            public void SaveToFile(StreamWriter sw, string ExtraInfo)
            {
                sw.WriteLine(ExtraInfo + " MaxIndex:");
                sw.WriteLine(mMaxIndex);

                for (int i = 0; i < mMaxIndex; i++)
                {
                    mArray[i].SaveToFile(sw, ExtraInfo);

                }

            }
            public void SaveToFile(string FileName)
            {
                StreamWriter sw = new StreamWriter(FileName);
                SaveToFile(sw, "");
                sw.Close();

            }
            public void LoadFromFile(string FileName)
            {
                StreamReader sr = new StreamReader(FileName);
                LoadFromFile(sr);
                sr.Close();

            }

        }
    }
}