using System;
using System.IO;



namespace RakabrotPluginInterface
{
    namespace RCommon
    {
        /// <summary>
        /// 
        /// </summary>
        public class RAreaOptimization : RArea
        {
            bool mInverse;
            public RAreaOptimization()
                : base()
            {
                // 
                // TODO: Add constructor logic here
                //
                Inverse = false;
            }
            public RAreaOptimization(double Left, double Top, double Right, double Bottom)
                : base(Left, Top, Right, Bottom)
            {
                // 
                // TODO: Add constructor logic here
                //
                mInverse = false;
            }
            public RAreaOptimization(RVector nTopLeft, RVector nBottomRight)
                : base(nTopLeft, nBottomRight)
            {
                mInverse = false;
            }
            public override bool Inside(double X, double Y)
            {
                return base.Inside(X, Y) != mInverse;
            }

            public bool Inverse
            {
                get
                {
                    return mInverse;
                }
                set
                {
                    mInverse = value;
                }
            }
            public override void SaveToFile(StreamWriter sw, string ExtraInfo)
            {
                base.SaveToFile(sw, ExtraInfo);
                sw.WriteLine(ExtraInfo + " inverse:");
                sw.WriteLine(Inverse);
            }

            public override void LoadFromFile(StreamReader sr)
            {
                String Line;

                base.LoadFromFile(sr);
                Line = sr.ReadLine();
                Line = sr.ReadLine();
                Inverse = System.Convert.ToBoolean(Line);

            }

        }
    }
}
