using System;
using System.IO;

using System.ComponentModel;
using RakabrotPluginInterface.RMath;

namespace RakabrotPluginInterface
{
    namespace RCommon
    {
        /// <summary>
        /// 
        /// </summary>
        public class RGridArea
        {

            RArea mArea;
            RGrid mGrid;
            public RArea GetArea() { return mArea; }
            public RGridArea()
            {
                // 
                // TODO: Add constructor logic here
                //

                mArea = new RArea();
                mGrid = new RGrid();
            }

            public void LoadFromFile(StreamReader sr)
            {
                mArea.LoadFromFile(sr);
                mGrid.LoadFromFile(sr);
            }

            public void SaveToFile(StreamWriter sw, string ExtraInfo)
            {
                mArea.SaveToFile(sw, ExtraInfo);
                mGrid.SaveToFile(sw, ExtraInfo);
            }

            public RArea Area
            {
                get
                {
                    return mArea;
                }
                set
                {
                    mArea = value;
                }
            }

            public RGrid Grid
            {
                get
                {
                    return mGrid;
                }
                set
                {
                    mGrid = value;
                }
            }
            [BrowsableAttribute(true), CategoryAttribute("Size")]
            public int Width
            {
                get
                {
                    return Grid.Width;
                }
                set
                {
                    Grid.Width = value;
                }
            }

            [BrowsableAttribute(true), CategoryAttribute("Size")]
            public int Height
            {
                get
                {
                    return Grid.Height;
                }
                set
                {
                    Grid.Height = value;
                }
            }

            [BrowsableAttribute(true), CategoryAttribute("Position")]
            public double Top
            {
                get
                {
                    return mArea.Top;
                }
                set
                {
                    mArea.Top = value;
                }
            }

            [BrowsableAttribute(true), CategoryAttribute("Position")]
            public double Left
            {
                get
                {
                    return mArea.Left;
                }
                set
                {
                    mArea.Left = value;
                }
            }

            [BrowsableAttribute(true), CategoryAttribute("Position")]
            public double Bottom
            {
                get
                {
                    return mArea.Bottom;
                }
                set
                {
                    mArea.Bottom = value;
                }
            }

            [BrowsableAttribute(true), CategoryAttribute("Position")]
            public double Right
            {
                get
                {
                    return mArea.Right;
                }
                set
                {
                    mArea.Right = value;
                }
            }
            public double StepX()
            {
                return (float)mArea.Width / (float)Width;
            }
            public double StepY()
            {
                return (float)mArea.Height / (float)Height;
            }
            public RVectorInt GetGridIndex(Complex Z)
            {
                return GetGridIndex(Z.Real, Z.Imag);
            }
            public RVectorInt GetGridIndex(double x, double y)
            {

                int Dx = (int)((x - mArea.Left) * StepX());
                int Dy = (int)((y - mArea.Top) * StepY());

                RVectorInt Result = new RVectorInt(Dx, Dy);
                return Result;

            }
            public void Copy(RGridArea nGridArea)
            {
                mArea.Copy(nGridArea.GetArea());
                mGrid.Copy(nGridArea.Grid);

            }
        }
    }
}