using System;
using System.IO;
using System.Drawing;
using RakabrotPluginInterface.RCommon;
//using RNGradient;
using System;
using Inferno.Utilities;

namespace RakabrotPluginInterface
{
    namespace RNumericImage
    {
        /// <summary>
        /// 
        /// </summary>
        /// 
        public class RNumericImagePallete : RNumericImageAbstract
        {

            public RNumericImagePallete()
                : base()
            {
                // 
                // TODO: Add constructor logic here
                //
                mGradient = new MarkerList();
            }

            public override bool GetChange()
            {

                return !freshBitmap || Gradient.CheckChange();
            }
            public override void InitImageSize(int nWidth, int nHeight)
            {


                base.InitImageSize(nWidth, nHeight);

            }
            public RNumericImagePallete(int nWidth, int nHeight)
                : base(nWidth, nHeight)
            {
                // 
                // TODO: Add constructor logic here
                //
                InitImageSize(nWidth, nHeight);
                mBitmapFileName = "c:\\fraktali\\test.bmp";
                mDataFileName = "C:\\fraktali\\NumericImage.dat";
                //            mGradient = new RGradient(256);
            }
            public RNumericImagePallete(RGrid nGrid)
                : base(nGrid)
            {
                InitImageSize(nGrid.Width, nGrid.Height);
                mBitmapFileName = "c:\\fraktali\\test.bmp";
                mDataFileName = "c:\\fraktali\\NumericImage.dat";
                //            mGradient = new RGradient(256);
            }
            public RNumericImagePallete(RGrid nGrid, MarkerList nGradient):base(nGrid, nGradient)
            {

            }


            public virtual void DrawImage(Graphics g)
            {

                if (!IsBitmapFresh())
                {
                    CalcBitmap();
                }
                g.DrawImage(
                    mBitmap,
                    0,
                    0,
                    mBitmap.Width,
                    mBitmap.Height);

            }
            public override void LoadDataFromFile(string FileName)
            {

                FileStream fs;

                fs = new FileStream(FileName, FileMode.Open, FileAccess.Read);
                BinaryReader r = new BinaryReader(fs);

                mGrid.Width = r.ReadInt16();
                mGrid.Height = r.ReadInt16();

                mData = new double[mGrid.Width * mGrid.Height];
                mLineClipper = new LineClipper(mGrid.Width, mGrid.Height);


                for (int i = 0; i < mGrid.Width; i++)
                    for (int j = 0; j < mGrid.Height; j++)
                    {
                        this[i, j] = r.ReadUInt16();
                    }

                freshBitmap = false;


            }
            public void LoadDataFromFilePart(string FileName)
            {

                FileStream fs;

                fs = new FileStream(FileName, FileMode.Open, FileAccess.Read);
                BinaryReader r = new BinaryReader(fs);

                mGrid.Width = r.ReadInt16() / 4;
                mGrid.Height = r.ReadInt16() / 4;

                mData = new double[mGrid.Width * mGrid.Height];
                mLineClipper = new LineClipper(mGrid.Width, mGrid.Height);


                for (int i = 0; i < mGrid.Width * 4; i++)
                    for (int j = 0; j < mGrid.Height * 4; j++)
                    {
                        this[i / 4, j / 4] = r.ReadUInt16();
                    }

                freshBitmap = false;


            }

            public override void CalcBitmap()
            {
                mBitmap = new Bitmap(mGrid.Width,
                    mGrid.Height, System.Drawing.Imaging.PixelFormat.Format24bppRgb);

                int bytes = mGrid.Width * mGrid.Height * 3;
                byte[] rgbValues = new byte[bytes];


                Rectangle rect = new Rectangle(0, 0, mGrid.Width, mGrid.Height);
                System.Drawing.Imaging.BitmapData bmpData =
                       mBitmap.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadWrite,
                       mBitmap.PixelFormat);

                IntPtr ptr = bmpData.Scan0;

                uint CurrentIndex = 0;
                uint CurrentIndexRGB = 0;

                System.Drawing.Color tColor;
                double tMaxValue;

                tMaxValue = mGradient.ConvertFunction(MaxValue);
                if (tMaxValue == 0)
                    tMaxValue = 1;
                for (int i = 0; i < mGrid.Height; i++)
                    for (int j = 0; j < mGrid.Width; j++)
                    {
                        tColor = mGradient.GetColor(
                            mGradient.ConvertFunction(mData[CurrentIndex]) / tMaxValue);
                        rgbValues[CurrentIndexRGB + 2] = tColor.R;
                        rgbValues[CurrentIndexRGB + 1] = tColor.G;
                        rgbValues[CurrentIndexRGB] = tColor.B;
                        CurrentIndex++;
                        CurrentIndexRGB += 3;
                    }

                freshBitmap = true;
                System.Runtime.InteropServices.Marshal.Copy(rgbValues, 0, ptr, bytes);
                mBitmap.UnlockBits(bmpData);
            }


        }
    }
}