using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using RakabrotPluginInterface.RCommon;
using CRFractal;
//using RNGradient;
using FractalAnimator;
using RNumericImage;
using AviFile;
using Inferno;
using System.Diagnostics;
using System.IO;
using RakabrotPluginInterface;

namespace Rakabrot
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    /// 


    //    public delegate void RefreshOptimizationDelegate(EventArgRefreshOptimization a);

	public class MainWindow : System.Windows.Forms.Form
    {
        public static string StartDirectory;
        private IContainer components;

		RFractal		mFractal;
		private System.Windows.Forms.Panel panelTop;
		private System.Windows.Forms.Panel panelBottom;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.MenuItem menuSave;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.Panel paneAll;
		private System.Windows.Forms.Panel Properties;
		private System.Windows.Forms.TabControl tabFractalProperties;
		private System.Windows.Forms.TabPage tabPageGrids;
		private System.Windows.Forms.TabControl tabGrids;
		private System.Windows.Forms.TabPage tabPageGridChoiceInput;
		private Rakabrot.RControlGridArea rControlGridAreaIn;
		private System.Windows.Forms.TabPage tabPageGridChoiceOutput;
        private Rakabrot.RControlGridArea rControlGridAreaOut;
		private System.Windows.Forms.TabPage tabPageFormula;
		private System.Windows.Forms.Panel panelFormulaInfo;
		private System.Windows.Forms.PropertyGrid propertyGridFormula;
		private System.Windows.Forms.Panel PanelFormulaButtons;
		private System.Windows.Forms.Panel PanelFormulaProperties;
		private System.Windows.Forms.Label labelFormula;
		private System.Windows.Forms.TabPage tabPageCalculations;
		private System.Windows.Forms.Panel panelCalculationsButtons;
        private System.Windows.Forms.Button ButtonCalculateFormula;
        private System.Windows.Forms.Panel Images;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuSaveAs;
		private System.Windows.Forms.MenuItem menuOpen;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton Seperator1;
		private System.Windows.Forms.ToolBarButton toolBarButtonGradient;
		private System.Windows.Forms.ToolBarButton toolBarSeparator1;
        private System.Windows.Forms.ToolBarButton toolBarOptimize;
        private RProgress rProgressCalculation;
        private Button ButtonRenderToDisk;
        private SaveFileDialog saveFileImage;
        private TabPage tabImages;
        private RControlFractalImages rControlFractalImages1;
        private Button button1;
        private ComboBox comboBox1Formule;
        private Button buttonSeFormula;
        private TabControl tabControlImages;
        private TabPage tabImageMandelBrot;
        private RControlImageGridPanel rControlImageGridPanel1;
        private TabPage tabPageBubhabrotOut;
        private Panel panelImage;
        private Panel panelSelection;
        private RControlImageGridPanel rControlImageColorings;
        private Label label1;
        private ComboBox comboBoxSelectDisplayMethod;
        private MenuItem menuItem3;
        private MenuItem menuItem4;
//        private RNGradient.FormGradient mFormGradient;
        private MenuItem menuItemHelp;
        private PropertyGrid propertyGridCalculations;
        private Panel panelCalculationsGrid;
        private TabPage tabPageOptimization;
        private RControlAreaArray rControlAreaArray1;
        private RControlColorGradient mFormGradientInferno;
		public MainWindow()

		{
			//
			// Required for Windows Form Designer support
			//
            StartDirectory = Directory.GetCurrentDirectory();
            InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			mFractal = new RFractal();
			//			propertyGrid1.SelectedObject = mFractal;
//			rControlImageGridPanel1.m

            InitFractalWindows();
            rControlImageGridPanel1.SetNumericImage(mFractal.Mandelbrot);

            rControlImageColorings.SetNumericImage(mFractal.BuddhabrotOut);

            rControlAreaArray1.SetArray(mFractal.Optimization);
            rControlImageGridPanel1.SetOptimization(mFractal.Optimization);
            rControlFractalImages1.Fractal = mFractal;
            comboBoxSelectDisplayMethod.Text = "Buddhabrot Outside";
            
            Bitmap BMP;
            /*
            RColorHolder mColorHolder = new RColorHolder();
            RAnimationConverter MConvertAnim = new RAnimationConverter("d:\\fraktali\\t.avi");

//            MConvertAnim.Convert("d:\\fraktali\\test");
            
            
            //AviManager aviManager = new AviManager("d:\\fraktali\\t.avi", true);
//            VideoStream aviStream = aviManager.GetVideoStream();
            //aviStream.GetFrameOpen();
//            Bitmap picFrame = new Bitmap(aviStream.GetBitmap(Convert.ToInt32(numPosition.Value)));
//            Bitmap picFrame = new Bitmap(aviStream.GetBitmap(Convert.ToInt32(0)));
            //                picFrame.Image =
  //            ;
 //           picFrame.Save("d:\\fraktali\\izlaz\\test1.bmp");
//            aviStream.GetFrameClose();
//            aviManager.Close();
            MConvertAnim.Convert("d:\\fraktali\\izlaz\\test");
//             mFractal.Mandelbrot.ConvertBmpToData(BMP);
            */
            /*            for (int i = 1; i < 300; i++)
                        {
                            string Name;
                            string Name2;

            //                if (i < 10)
            //                    Name = "D:\\Fraktali\\texture\\00" + i + ".jpg";
            //                else
            //                    if (i < 100)
            //                        Name = "D:\\Fraktali\\texture\\0" + i + ".jpg";
            //                    else
                                    Name = "D:\\Fraktali\\texture\\" + i + ".jpg";


                            BMP = new Bitmap(Name);
                            if (i < 10)
                                Name2 = "D:\\Fraktali\\izlaz00" + i + ".jpg";
                            else
                                if (i < 100)
                                    Name2 = "D:\\Fraktali\\izlaz0" + i + ".jpg";
                                else
                                    Name2 = "D:\\Fraktali\\izlaz" + i + ".jpg";

                            mFractal.Mandelbrot.ConvertBmpToData(BMP, mColorHolder);
                            mFractal.Mandelbrot.SaveBitMap(Name2);
                        }
                        //            BMP = new Bitmap("D:\\Fraktali\\texture\\Fractal2.jpg");
                        //            mFractal.Mandelbrot.ConvertBmpToData(BMP);
//                                    mFractal.Mandelbrot.SaveBitMap("d:\\fraktali\\Izlaz.jpg");

                        //            FractalAnimatorAbstract A;

            //            A = new FractalAnimatorAbstract();
        
              */
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainWindow));
            this.comboBoxSelectDisplayMethod = new System.Windows.Forms.ComboBox();
            this.panelTop = new System.Windows.Forms.Panel();
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.Seperator1 = new System.Windows.Forms.ToolBarButton();
            this.toolBarOptimize = new System.Windows.Forms.ToolBarButton();
            this.toolBarSeparator1 = new System.Windows.Forms.ToolBarButton();
            this.toolBarButtonGradient = new System.Windows.Forms.ToolBarButton();
            this.panelBottom = new System.Windows.Forms.Panel();
            this.statusBar1 = new System.Windows.Forms.StatusBar();
            this.panel1 = new System.Windows.Forms.Panel();
            this.paneAll = new System.Windows.Forms.Panel();
            this.Properties = new System.Windows.Forms.Panel();
            this.tabFractalProperties = new System.Windows.Forms.TabControl();
            this.tabPageCalculations = new System.Windows.Forms.TabPage();
            this.propertyGridCalculations = new System.Windows.Forms.PropertyGrid();
            this.panelCalculationsButtons = new System.Windows.Forms.Panel();
            this.button1 = new System.Windows.Forms.Button();
            this.ButtonRenderToDisk = new System.Windows.Forms.Button();
            this.rProgressCalculation = new RakabrotPluginInterface.RProgress();
            this.ButtonCalculateFormula = new System.Windows.Forms.Button();
            this.panelCalculationsGrid = new System.Windows.Forms.Panel();
            this.tabPageFormula = new System.Windows.Forms.TabPage();
            this.panelFormulaInfo = new System.Windows.Forms.Panel();
            this.propertyGridFormula = new System.Windows.Forms.PropertyGrid();
            this.PanelFormulaButtons = new System.Windows.Forms.Panel();
            this.buttonSeFormula = new System.Windows.Forms.Button();
            this.comboBox1Formule = new System.Windows.Forms.ComboBox();
            this.PanelFormulaProperties = new System.Windows.Forms.Panel();
            this.labelFormula = new System.Windows.Forms.Label();
            this.tabPageGrids = new System.Windows.Forms.TabPage();
            this.tabGrids = new System.Windows.Forms.TabControl();
            this.tabPageGridChoiceInput = new System.Windows.Forms.TabPage();
            this.rControlGridAreaIn = new Rakabrot.RControlGridArea();
            this.tabPageGridChoiceOutput = new System.Windows.Forms.TabPage();
            this.rControlGridAreaOut = new Rakabrot.RControlGridArea();
            this.tabImages = new System.Windows.Forms.TabPage();
            this.rControlFractalImages1 = new Rakabrot.RControlFractalImages();
            this.tabPageOptimization = new System.Windows.Forms.TabPage();
            this.rControlAreaArray1 = new Rakabrot.RControlAreaArray();
            this.Images = new System.Windows.Forms.Panel();
            this.tabControlImages = new System.Windows.Forms.TabControl();
            this.tabImageMandelBrot = new System.Windows.Forms.TabPage();
            this.rControlImageGridPanel1 = new Rakabrot.RControlImageGridPanel();
            this.tabPageBubhabrotOut = new System.Windows.Forms.TabPage();
            this.panelSelection = new System.Windows.Forms.Panel();
            this.label1 = new System.Windows.Forms.Label();
            this.panelImage = new System.Windows.Forms.Panel();
            this.rControlImageColorings = new Rakabrot.RControlImageGridPanel();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.menuSave = new System.Windows.Forms.MenuItem();
            this.menuExit = new System.Windows.Forms.MenuItem();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuSaveAs = new System.Windows.Forms.MenuItem();
            this.menuOpen = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.menuItemHelp = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.saveFileImage = new System.Windows.Forms.SaveFileDialog();
            this.panelTop.SuspendLayout();
            this.panelBottom.SuspendLayout();
            this.panel1.SuspendLayout();
            this.paneAll.SuspendLayout();
            this.Properties.SuspendLayout();
            this.tabFractalProperties.SuspendLayout();
            this.tabPageCalculations.SuspendLayout();
            this.panelCalculationsButtons.SuspendLayout();
            this.tabPageFormula.SuspendLayout();
            this.panelFormulaInfo.SuspendLayout();
            this.PanelFormulaButtons.SuspendLayout();
            this.PanelFormulaProperties.SuspendLayout();
            this.tabPageGrids.SuspendLayout();
            this.tabGrids.SuspendLayout();
            this.tabPageGridChoiceInput.SuspendLayout();
            this.tabPageGridChoiceOutput.SuspendLayout();
            this.tabImages.SuspendLayout();
            this.tabPageOptimization.SuspendLayout();
            this.Images.SuspendLayout();
            this.tabControlImages.SuspendLayout();
            this.tabImageMandelBrot.SuspendLayout();
            this.tabPageBubhabrotOut.SuspendLayout();
            this.panelSelection.SuspendLayout();
            this.panelImage.SuspendLayout();
            this.SuspendLayout();
            // 
            // comboBoxSelectDisplayMethod
            // 
            this.comboBoxSelectDisplayMethod.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;
            this.comboBoxSelectDisplayMethod.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxSelectDisplayMethod.FormattingEnabled = true;
            this.comboBoxSelectDisplayMethod.Items.AddRange(new object[] {
            "Buddhabrot Inside",
            "Buddhabrot Outside",
            "Calculation-Path Inside",
            "Calculation-Path Outside",
            "Time-Spent Inside",
            "Time-Spent Outside"});
            this.comboBoxSelectDisplayMethod.Location = new System.Drawing.Point(197, 13);
            this.comboBoxSelectDisplayMethod.Name = "comboBoxSelectDisplayMethod";
            this.comboBoxSelectDisplayMethod.Size = new System.Drawing.Size(296, 21);
            this.comboBoxSelectDisplayMethod.TabIndex = 0;
            this.comboBoxSelectDisplayMethod.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            // 
            // panelTop
            // 
            this.panelTop.Controls.Add(this.toolBar1);
            this.panelTop.Dock = System.Windows.Forms.DockStyle.Top;
            this.panelTop.Location = new System.Drawing.Point(0, 0);
            this.panelTop.Name = "panelTop";
            this.panelTop.Size = new System.Drawing.Size(1020, 56);
            this.panelTop.TabIndex = 0;
            // 
            // toolBar1
            // 
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.Seperator1,
            this.toolBarOptimize,
            this.toolBarSeparator1,
            this.toolBarButtonGradient});
            this.toolBar1.DropDownArrows = true;
            this.toolBar1.Location = new System.Drawing.Point(0, 0);
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ShowToolTips = true;
            this.toolBar1.Size = new System.Drawing.Size(1020, 42);
            this.toolBar1.TabIndex = 0;
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick_1);
            // 
            // Seperator1
            // 
            this.Seperator1.Name = "Seperator1";
            this.Seperator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolBarOptimize
            // 
            this.toolBarOptimize.Name = "toolBarOptimize";
            this.toolBarOptimize.Text = "Optimize";
            // 
            // toolBarSeparator1
            // 
            this.toolBarSeparator1.Name = "toolBarSeparator1";
            this.toolBarSeparator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolBarButtonGradient
            // 
            this.toolBarButtonGradient.Name = "toolBarButtonGradient";
            this.toolBarButtonGradient.Text = "Gradient";
            // 
            // panelBottom
            // 
            this.panelBottom.Controls.Add(this.statusBar1);
            this.panelBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panelBottom.Location = new System.Drawing.Point(0, 659);
            this.panelBottom.Name = "panelBottom";
            this.panelBottom.Size = new System.Drawing.Size(1020, 24);
            this.panelBottom.TabIndex = 1;
            // 
            // statusBar1
            // 
            this.statusBar1.Location = new System.Drawing.Point(0, 2);
            this.statusBar1.Name = "statusBar1";
            this.statusBar1.Size = new System.Drawing.Size(1020, 22);
            this.statusBar1.TabIndex = 0;
            this.statusBar1.Text = "statusBar1";
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.paneAll);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 56);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(1020, 603);
            this.panel1.TabIndex = 2;
            // 
            // paneAll
            // 
            this.paneAll.Controls.Add(this.Properties);
            this.paneAll.Controls.Add(this.Images);
            this.paneAll.Dock = System.Windows.Forms.DockStyle.Fill;
            this.paneAll.Location = new System.Drawing.Point(0, 0);
            this.paneAll.Name = "paneAll";
            this.paneAll.Size = new System.Drawing.Size(1020, 603);
            this.paneAll.TabIndex = 2;
            this.paneAll.Paint += new System.Windows.Forms.PaintEventHandler(this.paneAll_Paint);
            // 
            // Properties
            // 
            this.Properties.AllowDrop = true;
            this.Properties.Controls.Add(this.tabFractalProperties);
            this.Properties.Dock = System.Windows.Forms.DockStyle.Right;
            this.Properties.Location = new System.Drawing.Point(765, 0);
            this.Properties.Name = "Properties";
            this.Properties.Size = new System.Drawing.Size(255, 603);
            this.Properties.TabIndex = 3;
            // 
            // tabFractalProperties
            // 
            this.tabFractalProperties.Controls.Add(this.tabPageCalculations);
            this.tabFractalProperties.Controls.Add(this.tabPageFormula);
            this.tabFractalProperties.Controls.Add(this.tabPageGrids);
            this.tabFractalProperties.Controls.Add(this.tabImages);
            this.tabFractalProperties.Controls.Add(this.tabPageOptimization);
            this.tabFractalProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tabFractalProperties.Location = new System.Drawing.Point(0, 0);
            this.tabFractalProperties.Multiline = true;
            this.tabFractalProperties.Name = "tabFractalProperties";
            this.tabFractalProperties.SelectedIndex = 0;
            this.tabFractalProperties.Size = new System.Drawing.Size(255, 603);
            this.tabFractalProperties.TabIndex = 0;
            // 
            // tabPageCalculations
            // 
            this.tabPageCalculations.Controls.Add(this.propertyGridCalculations);
            this.tabPageCalculations.Controls.Add(this.panelCalculationsButtons);
            this.tabPageCalculations.Controls.Add(this.panelCalculationsGrid);
            this.tabPageCalculations.Location = new System.Drawing.Point(4, 40);
            this.tabPageCalculations.Name = "tabPageCalculations";
            this.tabPageCalculations.Size = new System.Drawing.Size(247, 559);
            this.tabPageCalculations.TabIndex = 2;
            this.tabPageCalculations.Text = "Calculations";
            this.tabPageCalculations.Visible = false;
            // 
            // propertyGridCalculations
            // 
            this.propertyGridCalculations.AccessibleDescription = "";
            this.propertyGridCalculations.HelpVisible = false;
            this.propertyGridCalculations.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.propertyGridCalculations.Location = new System.Drawing.Point(1, 3);
            this.propertyGridCalculations.Name = "propertyGridCalculations";
            this.propertyGridCalculations.Size = new System.Drawing.Size(236, 321);
            this.propertyGridCalculations.TabIndex = 0;
            this.propertyGridCalculations.ToolbarVisible = false;
            this.propertyGridCalculations.Click += new System.EventHandler(this.propertyGridCalculations_Click);
            // 
            // panelCalculationsButtons
            // 
            this.panelCalculationsButtons.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.panelCalculationsButtons.Controls.Add(this.button1);
            this.panelCalculationsButtons.Controls.Add(this.ButtonRenderToDisk);
            this.panelCalculationsButtons.Controls.Add(this.rProgressCalculation);
            this.panelCalculationsButtons.Controls.Add(this.ButtonCalculateFormula);
            this.panelCalculationsButtons.Location = new System.Drawing.Point(0, 357);
            this.panelCalculationsButtons.Name = "panelCalculationsButtons";
            this.panelCalculationsButtons.Size = new System.Drawing.Size(236, 238);
            this.panelCalculationsButtons.TabIndex = 1;
            // 
            // button1
            // 
            this.button1.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.button1.Location = new System.Drawing.Point(35, 114);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(152, 32);
            this.button1.TabIndex = 3;
            this.button1.Text = "Calculate to Disk";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // ButtonRenderToDisk
            // 
            this.ButtonRenderToDisk.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.ButtonRenderToDisk.Location = new System.Drawing.Point(35, 76);
            this.ButtonRenderToDisk.Name = "ButtonRenderToDisk";
            this.ButtonRenderToDisk.Size = new System.Drawing.Size(152, 32);
            this.ButtonRenderToDisk.TabIndex = 2;
            this.ButtonRenderToDisk.Text = "Render to Disk";
            this.ButtonRenderToDisk.Click += new System.EventHandler(this.ButtonRenderToDisk_Click);
            // 
            // rProgressCalculation
            // 
            this.rProgressCalculation.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.rProgressCalculation.Location = new System.Drawing.Point(0, 185);
            this.rProgressCalculation.Name = "rProgressCalculation";
            this.rProgressCalculation.Size = new System.Drawing.Size(236, 53);
            this.rProgressCalculation.TabIndex = 1;
            // 
            // ButtonCalculateFormula
            // 
            this.ButtonCalculateFormula.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.ButtonCalculateFormula.Location = new System.Drawing.Point(35, 38);
            this.ButtonCalculateFormula.Name = "ButtonCalculateFormula";
            this.ButtonCalculateFormula.Size = new System.Drawing.Size(152, 32);
            this.ButtonCalculateFormula.TabIndex = 0;
            this.ButtonCalculateFormula.Text = "Calculate";
            this.ButtonCalculateFormula.Click += new System.EventHandler(this.ButtonCalculateFormula_Click);
            // 
            // panelCalculationsGrid
            // 
            this.panelCalculationsGrid.Dock = System.Windows.Forms.DockStyle.Top;
            this.panelCalculationsGrid.Location = new System.Drawing.Point(0, 0);
            this.panelCalculationsGrid.Name = "panelCalculationsGrid";
            this.panelCalculationsGrid.Size = new System.Drawing.Size(247, 208);
            this.panelCalculationsGrid.TabIndex = 0;
            // 
            // tabPageFormula
            // 
            this.tabPageFormula.Controls.Add(this.panelFormulaInfo);
            this.tabPageFormula.Controls.Add(this.PanelFormulaButtons);
            this.tabPageFormula.Controls.Add(this.PanelFormulaProperties);
            this.tabPageFormula.Location = new System.Drawing.Point(4, 40);
            this.tabPageFormula.Name = "tabPageFormula";
            this.tabPageFormula.Size = new System.Drawing.Size(247, 559);
            this.tabPageFormula.TabIndex = 1;
            this.tabPageFormula.Text = "Formula";
            this.tabPageFormula.Visible = false;
            // 
            // panelFormulaInfo
            // 
            this.panelFormulaInfo.Controls.Add(this.propertyGridFormula);
            this.panelFormulaInfo.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelFormulaInfo.Location = new System.Drawing.Point(0, 144);
            this.panelFormulaInfo.Name = "panelFormulaInfo";
            this.panelFormulaInfo.Size = new System.Drawing.Size(247, 315);
            this.panelFormulaInfo.TabIndex = 2;
            // 
            // propertyGridFormula
            // 
            this.propertyGridFormula.Dock = System.Windows.Forms.DockStyle.Fill;
            this.propertyGridFormula.HelpVisible = false;
            this.propertyGridFormula.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.propertyGridFormula.Location = new System.Drawing.Point(0, 0);
            this.propertyGridFormula.Name = "propertyGridFormula";
            this.propertyGridFormula.Size = new System.Drawing.Size(247, 315);
            this.propertyGridFormula.TabIndex = 0;
            this.propertyGridFormula.ToolbarVisible = false;
            // 
            // PanelFormulaButtons
            // 
            this.PanelFormulaButtons.Controls.Add(this.buttonSeFormula);
            this.PanelFormulaButtons.Controls.Add(this.comboBox1Formule);
            this.PanelFormulaButtons.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.PanelFormulaButtons.Location = new System.Drawing.Point(0, 459);
            this.PanelFormulaButtons.Name = "PanelFormulaButtons";
            this.PanelFormulaButtons.Size = new System.Drawing.Size(247, 100);
            this.PanelFormulaButtons.TabIndex = 1;
            // 
            // buttonSeFormula
            // 
            this.buttonSeFormula.Location = new System.Drawing.Point(46, 63);
            this.buttonSeFormula.Name = "buttonSeFormula";
            this.buttonSeFormula.Size = new System.Drawing.Size(137, 27);
            this.buttonSeFormula.TabIndex = 3;
            this.buttonSeFormula.Text = "Set Formula";
            this.buttonSeFormula.UseVisualStyleBackColor = true;
            this.buttonSeFormula.Click += new System.EventHandler(this.buttonSeFormula_Click);
            // 
            // comboBox1Formule
            // 
            this.comboBox1Formule.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1Formule.FormattingEnabled = true;
            this.comboBox1Formule.Items.AddRange(new object[] {
            "ZPower",
            "ZPowerEx",
            "Sum"});
            this.comboBox1Formule.Location = new System.Drawing.Point(7, 36);
            this.comboBox1Formule.Name = "comboBox1Formule";
            this.comboBox1Formule.Size = new System.Drawing.Size(228, 21);
            this.comboBox1Formule.TabIndex = 0;
            this.comboBox1Formule.SelectedIndexChanged += new System.EventHandler(this.comboBox1Formule_SelectedIndexChanged);
            // 
            // PanelFormulaProperties
            // 
            this.PanelFormulaProperties.Controls.Add(this.labelFormula);
            this.PanelFormulaProperties.Dock = System.Windows.Forms.DockStyle.Top;
            this.PanelFormulaProperties.Location = new System.Drawing.Point(0, 0);
            this.PanelFormulaProperties.Name = "PanelFormulaProperties";
            this.PanelFormulaProperties.Size = new System.Drawing.Size(247, 144);
            this.PanelFormulaProperties.TabIndex = 0;
            // 
            // labelFormula
            // 
            this.labelFormula.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelFormula.Dock = System.Windows.Forms.DockStyle.Top;
            this.labelFormula.Location = new System.Drawing.Point(0, 0);
            this.labelFormula.Name = "labelFormula";
            this.labelFormula.Size = new System.Drawing.Size(247, 136);
            this.labelFormula.TabIndex = 0;
            this.labelFormula.Text = "label1";
            this.labelFormula.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tabPageGrids
            // 
            this.tabPageGrids.Controls.Add(this.tabGrids);
            this.tabPageGrids.Location = new System.Drawing.Point(4, 40);
            this.tabPageGrids.Name = "tabPageGrids";
            this.tabPageGrids.Size = new System.Drawing.Size(247, 559);
            this.tabPageGrids.TabIndex = 0;
            this.tabPageGrids.Text = "Grids";
            // 
            // tabGrids
            // 
            this.tabGrids.Controls.Add(this.tabPageGridChoiceInput);
            this.tabGrids.Controls.Add(this.tabPageGridChoiceOutput);
            this.tabGrids.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tabGrids.Location = new System.Drawing.Point(0, 0);
            this.tabGrids.Name = "tabGrids";
            this.tabGrids.SelectedIndex = 0;
            this.tabGrids.Size = new System.Drawing.Size(247, 559);
            this.tabGrids.TabIndex = 0;
            // 
            // tabPageGridChoiceInput
            // 
            this.tabPageGridChoiceInput.Controls.Add(this.rControlGridAreaIn);
            this.tabPageGridChoiceInput.Location = new System.Drawing.Point(4, 22);
            this.tabPageGridChoiceInput.Name = "tabPageGridChoiceInput";
            this.tabPageGridChoiceInput.Size = new System.Drawing.Size(236, 572);
            this.tabPageGridChoiceInput.TabIndex = 0;
            this.tabPageGridChoiceInput.Text = "Input";
            // 
            // rControlGridAreaIn
            // 
            this.rControlGridAreaIn.Dock = System.Windows.Forms.DockStyle.Fill;
            this.rControlGridAreaIn.GridArea = null;
            this.rControlGridAreaIn.Location = new System.Drawing.Point(0, 0);
            this.rControlGridAreaIn.Name = "rControlGridAreaIn";
            this.rControlGridAreaIn.Size = new System.Drawing.Size(236, 572);
            this.rControlGridAreaIn.TabIndex = 0;
            // 
            // tabPageGridChoiceOutput
            // 
            this.tabPageGridChoiceOutput.Controls.Add(this.rControlGridAreaOut);
            this.tabPageGridChoiceOutput.Location = new System.Drawing.Point(4, 22);
            this.tabPageGridChoiceOutput.Name = "tabPageGridChoiceOutput";
            this.tabPageGridChoiceOutput.Size = new System.Drawing.Size(236, 554);
            this.tabPageGridChoiceOutput.TabIndex = 1;
            this.tabPageGridChoiceOutput.Text = "Output";
            this.tabPageGridChoiceOutput.Visible = false;
            // 
            // rControlGridAreaOut
            // 
            this.rControlGridAreaOut.Dock = System.Windows.Forms.DockStyle.Fill;
            this.rControlGridAreaOut.GridArea = null;
            this.rControlGridAreaOut.Location = new System.Drawing.Point(0, 0);
            this.rControlGridAreaOut.Name = "rControlGridAreaOut";
            this.rControlGridAreaOut.Size = new System.Drawing.Size(236, 554);
            this.rControlGridAreaOut.TabIndex = 0;
            // 
            // tabImages
            // 
            this.tabImages.Controls.Add(this.rControlFractalImages1);
            this.tabImages.Location = new System.Drawing.Point(4, 40);
            this.tabImages.Name = "tabImages";
            this.tabImages.Padding = new System.Windows.Forms.Padding(3);
            this.tabImages.Size = new System.Drawing.Size(247, 559);
            this.tabImages.TabIndex = 3;
            this.tabImages.Text = "Images";
            this.tabImages.UseVisualStyleBackColor = true;
            // 
            // rControlFractalImages1
            // 
            this.rControlFractalImages1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.rControlFractalImages1.Fractal = null;
            this.rControlFractalImages1.Location = new System.Drawing.Point(3, 3);
            this.rControlFractalImages1.Name = "rControlFractalImages1";
            this.rControlFractalImages1.Size = new System.Drawing.Size(241, 553);
            this.rControlFractalImages1.TabIndex = 0;
            this.rControlFractalImages1.Load += new System.EventHandler(this.rControlFractalImages1_Load);
            // 
            // tabPageOptimization
            // 
            this.tabPageOptimization.Controls.Add(this.rControlAreaArray1);
            this.tabPageOptimization.Location = new System.Drawing.Point(4, 40);
            this.tabPageOptimization.Name = "tabPageOptimization";
            this.tabPageOptimization.Padding = new System.Windows.Forms.Padding(3);
            this.tabPageOptimization.Size = new System.Drawing.Size(247, 559);
            this.tabPageOptimization.TabIndex = 4;
            this.tabPageOptimization.Text = "Optimization";
            this.tabPageOptimization.UseVisualStyleBackColor = true;
            // 
            // rControlAreaArray1
            // 
            this.rControlAreaArray1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.rControlAreaArray1.Location = new System.Drawing.Point(3, 3);
            this.rControlAreaArray1.Name = "rControlAreaArray1";
            this.rControlAreaArray1.Size = new System.Drawing.Size(241, 553);
            this.rControlAreaArray1.TabIndex = 1;
            // 
            // Images
            // 
            this.Images.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.Images.Controls.Add(this.tabControlImages);
            this.Images.Dock = System.Windows.Forms.DockStyle.Left;
            this.Images.Location = new System.Drawing.Point(0, 0);
            this.Images.Name = "Images";
            this.Images.Size = new System.Drawing.Size(1020, 603);
            this.Images.TabIndex = 2;
            // 
            // tabControlImages
            // 
            this.tabControlImages.Controls.Add(this.tabImageMandelBrot);
            this.tabControlImages.Controls.Add(this.tabPageBubhabrotOut);
            this.tabControlImages.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tabControlImages.Location = new System.Drawing.Point(0, 0);
            this.tabControlImages.Name = "tabControlImages";
            this.tabControlImages.SelectedIndex = 0;
            this.tabControlImages.Size = new System.Drawing.Size(1018, 601);
            this.tabControlImages.TabIndex = 0;
            this.tabControlImages.Selected += new System.Windows.Forms.TabControlEventHandler(this.tabControlImages_Selected);
            this.tabControlImages.SelectedIndexChanged += new System.EventHandler(this.tabControlImages_SelectedIndexChanged);
            // 
            // tabImageMandelBrot
            // 
            this.tabImageMandelBrot.Controls.Add(this.rControlImageGridPanel1);
            this.tabImageMandelBrot.Location = new System.Drawing.Point(4, 22);
            this.tabImageMandelBrot.Name = "tabImageMandelBrot";
            this.tabImageMandelBrot.Size = new System.Drawing.Size(1010, 575);
            this.tabImageMandelBrot.TabIndex = 0;
            this.tabImageMandelBrot.Text = "MandelbBrot";
            // 
            // rControlImageGridPanel1
            // 
            this.rControlImageGridPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.rControlImageGridPanel1.Location = new System.Drawing.Point(0, 0);
            this.rControlImageGridPanel1.Name = "rControlImageGridPanel1";
            this.rControlImageGridPanel1.Size = new System.Drawing.Size(1010, 575);
            this.rControlImageGridPanel1.TabIndex = 0;
            // 
            // tabPageBubhabrotOut
            // 
            this.tabPageBubhabrotOut.Controls.Add(this.panelSelection);
            this.tabPageBubhabrotOut.Controls.Add(this.panelImage);
            this.tabPageBubhabrotOut.Location = new System.Drawing.Point(4, 22);
            this.tabPageBubhabrotOut.Name = "tabPageBubhabrotOut";
            this.tabPageBubhabrotOut.Size = new System.Drawing.Size(1010, 575);
            this.tabPageBubhabrotOut.TabIndex = 1;
            this.tabPageBubhabrotOut.Text = "Colorings";
            this.tabPageBubhabrotOut.Visible = false;
            this.tabPageBubhabrotOut.Click += new System.EventHandler(this.tabPageBubhabrotOut_Click);
            // 
            // panelSelection
            // 
            this.panelSelection.Controls.Add(this.label1);
            this.panelSelection.Controls.Add(this.comboBoxSelectDisplayMethod);
            this.panelSelection.Dock = System.Windows.Forms.DockStyle.Top;
            this.panelSelection.Location = new System.Drawing.Point(757, 0);
            this.panelSelection.Name = "panelSelection";
            this.panelSelection.Size = new System.Drawing.Size(253, 56);
            this.panelSelection.TabIndex = 1;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(78, 14);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(102, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = "Display Method";
            // 
            // panelImage
            // 
            this.panelImage.Controls.Add(this.rControlImageColorings);
            this.panelImage.Dock = System.Windows.Forms.DockStyle.Left;
            this.panelImage.Location = new System.Drawing.Point(0, 0);
            this.panelImage.Name = "panelImage";
            this.panelImage.Size = new System.Drawing.Size(757, 575);
            this.panelImage.TabIndex = 0;
            // 
            // rControlImageColorings
            // 
            this.rControlImageColorings.Dock = System.Windows.Forms.DockStyle.Fill;
            this.rControlImageColorings.Location = new System.Drawing.Point(0, 0);
            this.rControlImageColorings.Name = "rControlImageColorings";
            this.rControlImageColorings.Size = new System.Drawing.Size(757, 575);
            this.rControlImageColorings.TabIndex = 1;
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 4;
            this.menuItem2.Text = "Donate";
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.DefaultExt = "txt";
            // 
            // menuSave
            // 
            this.menuSave.Index = 0;
            this.menuSave.Text = "Save";
            this.menuSave.Click += new System.EventHandler(this.menuSave_Click);
            // 
            // menuExit
            // 
            this.menuExit.Index = 3;
            this.menuExit.Text = "Exit";
            this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1,
            this.menuItem3});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuSave,
            this.menuSaveAs,
            this.menuOpen,
            this.menuExit,
            this.menuItem2});
            this.menuItem1.Text = "File";
            // 
            // menuSaveAs
            // 
            this.menuSaveAs.Index = 1;
            this.menuSaveAs.Text = "Save As";
            this.menuSaveAs.Click += new System.EventHandler(this.menuSaveAs_Click);
            // 
            // menuOpen
            // 
            this.menuOpen.Index = 2;
            this.menuOpen.Text = "Open";
            this.menuOpen.Click += new System.EventHandler(this.menuOpen_Click);
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 1;
            this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemHelp,
            this.menuItem4});
            this.menuItem3.Text = "Help";
            // 
            // menuItemHelp
            // 
            this.menuItemHelp.Index = 0;
            this.menuItemHelp.Text = "Help";
            this.menuItemHelp.Click += new System.EventHandler(this.menuItemHelp_Click);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 1;
            this.menuItem4.Text = "About";
            this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
            // 
            // MainWindow
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1020, 683);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.panelBottom);
            this.Controls.Add(this.panelTop);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.mainMenu1;
            this.Name = "MainWindow";
            this.Text = "RakaBrot";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.SizeChanged += new System.EventHandler(this.MainWindow_SizeChanged);
            this.Activated += new System.EventHandler(this.MainWindow_Activated);
            this.panelTop.ResumeLayout(false);
            this.panelTop.PerformLayout();
            this.panelBottom.ResumeLayout(false);
            this.panel1.ResumeLayout(false);
            this.paneAll.ResumeLayout(false);
            this.Properties.ResumeLayout(false);
            this.tabFractalProperties.ResumeLayout(false);
            this.tabPageCalculations.ResumeLayout(false);
            this.panelCalculationsButtons.ResumeLayout(false);
            this.tabPageFormula.ResumeLayout(false);
            this.panelFormulaInfo.ResumeLayout(false);
            this.PanelFormulaButtons.ResumeLayout(false);
            this.PanelFormulaProperties.ResumeLayout(false);
            this.tabPageGrids.ResumeLayout(false);
            this.tabGrids.ResumeLayout(false);
            this.tabPageGridChoiceInput.ResumeLayout(false);
            this.tabPageGridChoiceOutput.ResumeLayout(false);
            this.tabImages.ResumeLayout(false);
            this.tabPageOptimization.ResumeLayout(false);
            this.Images.ResumeLayout(false);
            this.tabControlImages.ResumeLayout(false);
            this.tabImageMandelBrot.ResumeLayout(false);
            this.tabPageBubhabrotOut.ResumeLayout(false);
            this.panelSelection.ResumeLayout(false);
            this.panelSelection.PerformLayout();
            this.panelImage.ResumeLayout(false);
            this.ResumeLayout(false);

		}

		#endregion

        void MyEvents() 
        {
            this.rControlAreaArray1.NewOptimization += new NewOptimizationEventHandler(SetToOptimizations);

        
        }
        void SetToOptimizations() 
        {
            ResolveArea("Optimize") ;
        }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainWindow());
		}

		private void MainWindow_Activated(object sender, System.EventArgs e)
		{
			rControlImageGridPanel1.rPictureBoxArea1.SetSelectedArea(mFractal.InputGrid.GetArea());
			rControlImageGridPanel1.rPictureBoxArea1.SetProperty(rControlGridAreaIn);
            rControlImageGridPanel1.rPictureBoxArea1.SetArrayProperty(rControlAreaArray1);

            rControlImageColorings.rPictureBoxArea1.SetSelectedArea(mFractal.OutputGrid.GetArea());
            rControlImageColorings.rPictureBoxArea1.SetProperty(rControlGridAreaOut);


         
            mFractal.SetProgress(rProgressCalculation);
            labelFormula.Text = mFractal.GetFormula().GetFormulaString();
            

		}
		private void saveFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			
		}
        
        
		private void menuSave_Click(object sender, System.EventArgs e)
		{
            try
            {
                mFractal.SaveToFile();
                MessageBox.Show("File saved to :" + mFractal.FileName);
            }
            catch
            {
                MessageBox.Show("Could not save File");
            }
            

          
		}

		public void FileDialogsInit()
		{
		}

		private void menuOpen_Click(object sender, System.EventArgs e)
		{

            openFileDialog1.Filter = "Rakabrot Project(*.rpr)|*.rpr|All(*.*)|*.*";
            openFileDialog1.FilterIndex = 1;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    
                    mFractal.FileName = openFileDialog1.FileName;
                    mFractal.LoadFromFile();
                    RefreshFractalWindows();
                }
                catch 
                {
                    MessageBox.Show("Could not open file");
                }
            }
		}

		public void InitFractalWindows()
		{
			rControlGridAreaIn.GridArea  = mFractal.InputGrid;
			rControlGridAreaOut.GridArea = mFractal.OutputGrid;

			propertyGridCalculations.SelectedObject	= mFractal.mCalculationInfo;
            propertyGridFormula.SelectedObject = mFractal.GetFormula();	
				
		}

		public void RefreshFractalWindows()
		{
			rControlGridAreaIn.TotalRefresh();
			rControlGridAreaOut.TotalRefresh();
			propertyGridCalculations.Refresh();

			propertyGridFormula.Refresh();
			labelFormula.Text   = mFractal.GetFormula().GetFormulaString();
			labelFormula.Refresh();
		}

		private void rControlImageGridPanel1_Click(object sender, System.EventArgs e)
		{
			RefreshFractalWindows();
		}

		private void rControlImageGridPanel1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void tabImageMandelBrot_Click(object sender, System.EventArgs e)
		{
		
		}

        private void ButtonCalculateFormula_Click(object sender, System.EventArgs e)
        {
            statusBar1.Text = "Input area mode";
            rControlImageGridPanel1.SetMode(RPictureBoxAreaPanel.RControlMode.InputArea);
            rControlImageGridPanel1.rPictureBoxArea1.SetSelectedArea(mFractal.InputGrid.GetArea());
            toolBarOptimize.Text = "Optimize";

            mFractal.Calculate();
            rControlImageGridPanel1.rPictureBoxArea1.ChangeAreaToSelectedArea();
//            tabImageMandelBrot.Refresh();

            if (mFractal.mCalculationInfo.MSet)
            {
                rControlImageGridPanel1.SetNumericImage(mFractal.Mandelbrot);
                rControlImageGridPanel1.rPictureBoxArea1.DrawSelected(true);
            }
           rControlImageColorings.SetNumericImage(mFractal.BuddhabrotOut);


            if (mFractal.mCalculationInfo.BuddhabrotOutside)
                rControlImageColorings.rPictureBoxArea1.DrawSelected(true);

        }
		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
		}


        void ResolveArea(string text) 
        {
                    // Insert code to save the file.
            if (text == "Optimize")
                    {
                        statusBar1.Text = "Optimize mode";
                        toolBarOptimize.Text = "Input Area";
                        //						RPictureBoxArea.RControlMode
                        rControlImageGridPanel1.SetMode(RPictureBoxAreaPanel.RControlMode.Optimization);
                        rControlImageGridPanel1.SetSelectedArea(mFractal.Optimization.GetActive());
                        //						rControlImageGridPanel1.rPictureBoxArea1.SetSelectedArea();
                    }
                    else
                    {
                        if (text == "Input Area")
                        {
                            statusBar1.Text = "Input area mode";
                            rControlImageGridPanel1.SetMode(RPictureBoxAreaPanel.RControlMode.InputArea);
                            rControlImageGridPanel1.rPictureBoxArea1.SetSelectedArea(mFractal.InputGrid.GetArea());
                            toolBarOptimize.Text = "Optimize";
                        }
                    }

        }
		private void toolBar1_ButtonClick_1(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{

			switch(toolBar1.Buttons.IndexOf(e.Button))
			{
				case 0:
					// Insert code to open the file.
					break; 
				case 1:
					// Insert code to save the file.


                    ResolveArea(toolBarOptimize.Text);
                    /*
					if(toolBarOptimize.Text == "Optimize")
					{
						statusBar1.Text      = "Optimize mode";
						toolBarOptimize.Text = "Input Area";
//						RPictureBoxArea.RControlMode
						rControlImageGridPanel1.SetMode(RPictureBoxArea.RControlMode.Optimization);
						rControlImageGridPanel1.SetSelectedArea(mFractal.Optimization.GetActive());
						//						rControlImageGridPanel1.rPictureBoxArea1.SetSelectedArea();
					}
					else
					{
						if(toolBarOptimize.Text == "Input Area")
						{
                            statusBar1.Text = "Input area mode";
                            rControlImageGridPanel1.SetMode(RPictureBoxArea.RControlMode.InputArea);
                            rControlImageGridPanel1.rPictureBoxArea1.SetSelectedArea(mFractal.InputGrid.GetArea());
                            toolBarOptimize.Text = "Optimize";
                        }
                      
					}
                     */ 
					//					toolBarInputArea.
					break; 
				case 2:
					// Insert code to print the file.    
					//					toolBarInputArea.Pushed = false;
					break; 
				case 3:
					// Insert code to print the file.    
					//					toolBarInputArea.Pushed = false;
                    GradientClick();
        			break; 
			}

		}

        void NewGradient() 
        {
                rControlImageGridPanel1.rPictureBoxArea1.DrawSelected(true);
                rControlImageColorings.rPictureBoxArea1.DrawSelected(true);
        }

        private void GradientClick()
        {
            int i = tabControlImages.SelectedIndex;


            //mFormGradient = new RNGradient.FormGradient();
            mFormGradientInferno = new RControlColorGradient();
            
            
             switch (i)
              {
                  case 0:
                      mFormGradientInferno.SetMarkers(mFractal.Mandelbrot.Gradient);
                      break;
                  case 1:

                      mFormGradientInferno.SetMarkers(mFractal.BuddhabrotOut.Gradient);
                      if (comboBoxSelectDisplayMethod.Text == "Buddhabrot Outside")
                      {
                          mFormGradientInferno.SetMarkers(mFractal.BuddhabrotOut.Gradient);


                      }

                      if (comboBoxSelectDisplayMethod.Text == "Buddhabrot Inside")
                      {
                          mFormGradientInferno.SetMarkers( mFractal.BuddhabrotIn.Gradient);

                      }
                      if (comboBoxSelectDisplayMethod.Text == "Calculation-Path Outside")
                      {
                          mFormGradientInferno.SetMarkers( mFractal.CalculationPathOut.Gradient);
                      }
                      if (comboBoxSelectDisplayMethod.Text == "Calculation-Path Inside")
                      {
                          mFormGradientInferno.SetMarkers(mFractal.CalculationPathIn.Gradient);

                      }

                      if (comboBoxSelectDisplayMethod.Text == "Time-Spent Outside")
                      {
                          mFormGradientInferno.SetMarkers(mFractal.TimeSpentOut.Gradient);
                      }
                      if (comboBoxSelectDisplayMethod.Text == "Time-Spent Inside")
                      {
                          mFormGradientInferno.SetMarkers( mFractal.TimeSpentIn.Gradient);
                      }
                      break;
                  default:
                      break;
              }

              mFormGradientInferno.UpdatePalette += new UpdatePaletteEventHandler(rControlImageColorings.rPictureBoxArea1.DrawSelected);
              mFormGradientInferno.UpdatePalette += new UpdatePaletteEventHandler(rControlImageGridPanel1.rPictureBoxArea1.DrawSelected);
              mFormGradientInferno.Show();
           
		
        }
		
		private void menuExit_Click(object sender, System.EventArgs e)
		{
            if(MessageBox.Show("Do you wish to save the project once more", " ? ",MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
            }
            
            Close();

		}

		private void rControlAreaArray1_Load(object sender, System.EventArgs e)
		{
		
		}

        private void tabControlImages_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (tabControlImages.SelectedIndex )
            {
                case 0:
                    rControlImageGridPanel1.rPictureBoxArea1.DrawSelected(true);
                    
                    
                    //rControlImageGridPanel1.RefreshImage();
                    break;
                case 1:
                rControlImageColorings.rPictureBoxArea1.DrawSelected(true);
                    
                    //rControlImageColorings.RefreshImage();
                    break;
                

            }

    
        }

        private void ButtonRenderToDisk_Click(object sender, EventArgs e)
        {

            mFractal.RenderToDisk();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            mFractal.CalculateToDisk();
        }

        private void rControlFractalImages1_Load(object sender, EventArgs e)
        {

        }

        private void propertyGridCalculations_Click(object sender, EventArgs e)
        {
        }

        private void buttonSeFormula_Click(object sender, EventArgs e)
        {
           mFractal.SetFormula(comboBox1Formule.Text);
           propertyGridFormula.SelectedObject = mFractal.GetFormula();	

        }

        private void tabControlImages_Selected(object sender, TabControlEventArgs e)
        {
         //   rControlFractalImages1.Refresh();
        }

        private void rCIGPBuddhaBrot_Load(object sender, EventArgs e)
        {

        }

        private void tabPageBubhabrotOut_Click(object sender, EventArgs e)
        {

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxSelectDisplayMethod.Text == "Buddhabrot Outside") 
            {
                rControlImageColorings.SetNumericImage(mFractal.BuddhabrotOut);

                if (mFractal.mCalculationInfo.BuddhabrotOutside)
                    rControlImageColorings.rPictureBoxArea1.DrawSelected(true);
            
            }

            if (comboBoxSelectDisplayMethod.Text == "Buddhabrot Inside")
            {
                rControlImageColorings.SetNumericImage(mFractal.BuddhabrotIn);

                if (mFractal.mCalculationInfo.BuddhabrotInside)
                    rControlImageColorings.rPictureBoxArea1.DrawSelected(true);

            }
            if (comboBoxSelectDisplayMethod.Text == "Calculation-Path Outside")
            {
                rControlImageColorings.SetNumericImage(mFractal.CalculationPathOut);

                if (mFractal.mCalculationInfo.CalculationPathOutside)
                    rControlImageColorings.rPictureBoxArea1.DrawSelected(true);

            }
            if (comboBoxSelectDisplayMethod.Text == "Calculation-Path Inside")
            {
                rControlImageColorings.SetNumericImage(mFractal.CalculationPathIn);

                if (mFractal.mCalculationInfo.CalculationPathInside)
                    rControlImageColorings.rPictureBoxArea1.DrawSelected(true);

            }

            if (comboBoxSelectDisplayMethod.Text == "Time-Spent Outside")
            {
                rControlImageColorings.SetNumericImage(mFractal.TimeSpentOut);

                if (mFractal.mCalculationInfo.TimeSpentOutside)
                    rControlImageColorings.rPictureBoxArea1.DrawSelected(true);

            }
            if (comboBoxSelectDisplayMethod.Text == "Time-Spent Inside")
            {
                rControlImageColorings.SetNumericImage(mFractal.TimeSpentIn);

                if (mFractal.mCalculationInfo.TimeSpentInside)
                    rControlImageColorings.rPictureBoxArea1.DrawSelected(true);

            }


        }

        private void comboBox1Formule_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void menuItem4_Click(object sender, EventArgs e)
        {
            AboutDialog mAbout;

            mAbout = new AboutDialog();

            mAbout.Show();
        }

        private void menuItemHelp_Click(object sender, EventArgs e)
        {
            Process p = new Process();
            p.StartInfo.FileName = StartDirectory+ "\\Help\\Rakabrot.chm";
            p.Start();
        }

        private void menuSaveAs_Click(object sender, EventArgs e)
        {
            saveFileDialog1.Filter = "Rakabrot Project(*.rpr)|*.rpr|All(*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    mFractal.FileName = saveFileDialog1.FileName;
                    mFractal.SaveToFile();
                }
                catch
                {
                    MessageBox.Show("Could not sae File");
                }
            }
        }

        private void paneAll_Paint(object sender, PaintEventArgs e)
        {

        }

        private void MainWindow_SizeChanged(object sender, EventArgs e)
        {
            this.panelImage.Width = this.Width - this.Properties.Width;
            this.tabControlImages.Width = this.Width - this.Properties.Width;
        }

        

       



	}

   
   
}
