using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using RakabrotPluginInterface.RCommon;

namespace Rakabrot
{
	/// <summary>
	/// Summary description for RControlAreaArray.
	/// </summary>
    /// 
    public delegate void NewOptimizationEventHandler();


	

	public class RControlAreaArray : System.Windows.Forms.UserControl
	{


        public event NewOptimizationEventHandler NewOptimization;

		private System.Windows.Forms.Panel AreaProperties;
		private System.Windows.Forms.Panel Active;
		private System.Windows.Forms.Panel GlobalButtons;
		private System.Windows.Forms.Panel ActiveButtons;
		private System.Windows.Forms.Button NewArea;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Panel panelPropertyGrid;
		private System.Windows.Forms.PropertyGrid propertyGrid1;
		private System.Windows.Forms.ComboBox comboBoxActiveArea;
		private System.Windows.Forms.Label labelActiveIndex;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button SaveOptimization;
		private System.Windows.Forms.Button LoadOptimization;
		private System.Windows.Forms.SaveFileDialog saveFileOptimization;
        private System.Windows.Forms.OpenFileDialog openFileOptimization;
		private RAreaOptimizationArray		mArray;
        
      

		public RControlAreaArray()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
		//	propertyGrid1.SelectedObject = mArray.GetActive();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.AreaProperties = new System.Windows.Forms.Panel();
            this.labelActiveIndex = new System.Windows.Forms.Label();
            this.comboBoxActiveArea = new System.Windows.Forms.ComboBox();
            this.Active = new System.Windows.Forms.Panel();
            this.panelPropertyGrid = new System.Windows.Forms.Panel();
            this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
            this.ActiveButtons = new System.Windows.Forms.Panel();
            this.GlobalButtons = new System.Windows.Forms.Panel();
            this.LoadOptimization = new System.Windows.Forms.Button();
            this.SaveOptimization = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.NewArea = new System.Windows.Forms.Button();
            this.saveFileOptimization = new System.Windows.Forms.SaveFileDialog();
            this.openFileOptimization = new System.Windows.Forms.OpenFileDialog();
            this.AreaProperties.SuspendLayout();
            this.Active.SuspendLayout();
            this.panelPropertyGrid.SuspendLayout();
            this.GlobalButtons.SuspendLayout();
            this.SuspendLayout();
            // 
            // AreaProperties
            // 
            this.AreaProperties.Controls.Add(this.labelActiveIndex);
            this.AreaProperties.Controls.Add(this.comboBoxActiveArea);
            this.AreaProperties.Dock = System.Windows.Forms.DockStyle.Top;
            this.AreaProperties.Location = new System.Drawing.Point(0, 0);
            this.AreaProperties.Name = "AreaProperties";
            this.AreaProperties.Size = new System.Drawing.Size(256, 104);
            this.AreaProperties.TabIndex = 0;
            // 
            // labelActiveIndex
            // 
            this.labelActiveIndex.Location = new System.Drawing.Point(32, 24);
            this.labelActiveIndex.Name = "labelActiveIndex";
            this.labelActiveIndex.Size = new System.Drawing.Size(184, 23);
            this.labelActiveIndex.TabIndex = 1;
            this.labelActiveIndex.Text = "Active index";
            // 
            // comboBoxActiveArea
            // 
            this.comboBoxActiveArea.Location = new System.Drawing.Point(32, 56);
            this.comboBoxActiveArea.Name = "comboBoxActiveArea";
            this.comboBoxActiveArea.Size = new System.Drawing.Size(192, 21);
            this.comboBoxActiveArea.TabIndex = 0;
            this.comboBoxActiveArea.Text = "empty";
            this.comboBoxActiveArea.SelectedIndexChanged += new System.EventHandler(this.comboBoxActiveArea_SelectedIndexChanged);
            // 
            // Active
            // 
            this.Active.Controls.Add(this.panelPropertyGrid);
            this.Active.Controls.Add(this.ActiveButtons);
            this.Active.Controls.Add(this.GlobalButtons);
            this.Active.Dock = System.Windows.Forms.DockStyle.Fill;
            this.Active.Location = new System.Drawing.Point(0, 104);
            this.Active.Name = "Active";
            this.Active.Size = new System.Drawing.Size(256, 360);
            this.Active.TabIndex = 1;
            // 
            // panelPropertyGrid
            // 
            this.panelPropertyGrid.Controls.Add(this.propertyGrid1);
            this.panelPropertyGrid.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelPropertyGrid.Location = new System.Drawing.Point(0, 0);
            this.panelPropertyGrid.Name = "panelPropertyGrid";
            this.panelPropertyGrid.Size = new System.Drawing.Size(256, 152);
            this.panelPropertyGrid.TabIndex = 2;
            // 
            // propertyGrid1
            // 
            this.propertyGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.propertyGrid1.Location = new System.Drawing.Point(0, 0);
            this.propertyGrid1.Name = "propertyGrid1";
            this.propertyGrid1.Size = new System.Drawing.Size(256, 152);
            this.propertyGrid1.TabIndex = 0;
            // 
            // ActiveButtons
            // 
            this.ActiveButtons.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.ActiveButtons.Location = new System.Drawing.Point(0, 152);
            this.ActiveButtons.Name = "ActiveButtons";
            this.ActiveButtons.Size = new System.Drawing.Size(256, 48);
            this.ActiveButtons.TabIndex = 1;
            // 
            // GlobalButtons
            // 
            this.GlobalButtons.Controls.Add(this.LoadOptimization);
            this.GlobalButtons.Controls.Add(this.SaveOptimization);
            this.GlobalButtons.Controls.Add(this.button1);
            this.GlobalButtons.Controls.Add(this.NewArea);
            this.GlobalButtons.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.GlobalButtons.Location = new System.Drawing.Point(0, 200);
            this.GlobalButtons.Name = "GlobalButtons";
            this.GlobalButtons.Size = new System.Drawing.Size(256, 160);
            this.GlobalButtons.TabIndex = 0;
            // 
            // LoadOptimization
            // 
            this.LoadOptimization.Location = new System.Drawing.Point(40, 104);
            this.LoadOptimization.Name = "LoadOptimization";
            this.LoadOptimization.Size = new System.Drawing.Size(160, 24);
            this.LoadOptimization.TabIndex = 3;
            this.LoadOptimization.Text = "Load Optimization";
            this.LoadOptimization.Click += new System.EventHandler(this.LoadOptimization_Click);
            // 
            // SaveOptimization
            // 
            this.SaveOptimization.Location = new System.Drawing.Point(40, 72);
            this.SaveOptimization.Name = "SaveOptimization";
            this.SaveOptimization.Size = new System.Drawing.Size(160, 24);
            this.SaveOptimization.TabIndex = 2;
            this.SaveOptimization.Text = "Save Optimization";
            this.SaveOptimization.Click += new System.EventHandler(this.SaveOptimization_Click);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(40, 40);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(160, 24);
            this.button1.TabIndex = 1;
            this.button1.Text = "Delete Area";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // NewArea
            // 
            this.NewArea.Location = new System.Drawing.Point(40, 8);
            this.NewArea.Name = "NewArea";
            this.NewArea.Size = new System.Drawing.Size(160, 24);
            this.NewArea.TabIndex = 0;
            this.NewArea.Text = "NewArea";
            this.NewArea.Click += new System.EventHandler(this.NewArea_Click);
            // 
            // RControlAreaArray
            // 
            this.Controls.Add(this.Active);
            this.Controls.Add(this.AreaProperties);
            this.Name = "RControlAreaArray";
            this.Size = new System.Drawing.Size(256, 464);
            this.AreaProperties.ResumeLayout(false);
            this.Active.ResumeLayout(false);
            this.panelPropertyGrid.ResumeLayout(false);
            this.GlobalButtons.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		private void NewArea_Click(object sender, System.EventArgs e)
		{
			mArray.AddArea();
            FillComboBox();
            propertyGrid1.SelectedObject = mArray.GetActive();
            if (NewOptimization != null)
                NewOptimization();

            
        }
		private void FillComboBox()
		{
			comboBoxActiveArea.Items.Clear();
			for(int i = 0; i < mArray.GetMaxIndex(); i++)
			{
				comboBoxActiveArea.Items.Add(i);
			}
			comboBoxActiveArea.Text   = Convert.ToString(mArray.Active);
		}
		private void button1_Click(object sender, System.EventArgs e)
		{
			mArray.DeleteActive();
			FillComboBox();
		}

		private void comboBoxActiveArea_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			mArray.Active = Convert.ToInt16(comboBoxActiveArea.Text);
			propertyGrid1.SelectedObject = mArray.GetActive();
            if (NewOptimization != null)
                NewOptimization();

		}
		public void TotalRefresh()
		{
			Refresh();
			if(propertyGrid1 != null)
				propertyGrid1.Refresh();
		}
		public	void SetArray(RAreaOptimizationArray		nArray)
		{
			mArray  = nArray;
		}

		private void SaveOptimization_Click(object sender, System.EventArgs e)
		{

//					private System.Windows.Forms.SaveFileDialog saveFileOptimization;
//		private System.Windows.Forms.OpenFileDialog openFileOptimization;

            saveFileOptimization.Filter = "Rakabrot Optimization Array(*.roa)|*.roa|All(*.*)|*.*";
            saveFileOptimization.FilterIndex = 1;

			if (saveFileOptimization.ShowDialog() == DialogResult.OK)
			{
				if(mArray!= null )
					mArray.SaveToFile(saveFileOptimization.FileName);

			}

		}

		private void LoadOptimization_Click(object sender, System.EventArgs e)
		{
            openFileOptimization.Filter = "Rakabrot Optimization Array(*.roa)|*.roa|All(*.*)|*.*";
            openFileOptimization.FilterIndex = 1;


			if (openFileOptimization.ShowDialog() == DialogResult.OK)
			{
				if(mArray!= null )
					mArray.LoadFromFile(openFileOptimization.FileName);

                FillComboBox();
                propertyGrid1.SelectedObject = mArray.GetActive();

            }
		
		}

   	}
}
