using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using CRFractal;
using RakabrotPluginInterface.RNumericImage;

namespace Rakabrot
{
    public partial class RControlFractalImages : UserControl
    {
        public enum RFractalType
        {
            Mandelbrot = 0,
            BuddhabrotIn = 1,
            BuddhabrotOut = 2,
            CalculationPathIn = 3,
            CalculationPathOut = 4,
            TimeSpentIn = 5,
            TimeSpentOut = 6
        }
        RFractal                mFractal;
        RFractalType            mActiveFractalImage;

        public RControlFractalImages()
        {
            InitializeComponent();
            mActiveFractalImage = RFractalType.Mandelbrot;
        }

        public RFractal Fractal
        {
            get
            {
                return mFractal;
            }
            set
            {
                mFractal = value;
            }
        }

        private void buttonLoadNumericImage_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Rakabrot Numeric Image(*.rni)|*.rni|All(*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
       //     saveFileNumericImage.FileName = comboBoxSelectDisplayMethod.Text;


                        if (openFileDialog1.ShowDialog() == DialogResult.OK)
                        {
                            try
                            {
                                GetActiveNumericImage().LoadDataFromFile(openFileDialog1.FileName);
                            }
                            catch
                            { 
                            }
                        }
            
        }

        
        RNumericImageAbstract GetActiveNumericImage() 
        {

            if (comboBoxSelectDisplayMethod.Text == "Mandelbrot")
            {
                return mFractal.Mandelbrot;
            }
            if (comboBoxSelectDisplayMethod.Text == "Buddhabrot Outside")
            {
                return mFractal.BuddhabrotOut;
            }
            if (comboBoxSelectDisplayMethod.Text == "Buddhabrot Inside")
            {
                return mFractal.BuddhabrotIn;
            }
            if (comboBoxSelectDisplayMethod.Text == "Calculation-Path Outside")
            {
                return mFractal.CalculationPathOut;
            }
            if (comboBoxSelectDisplayMethod.Text == "Calculation-Path Inside")
            {
                return mFractal.CalculationPathIn;
            }
            if (comboBoxSelectDisplayMethod.Text == "Time-Spent Outside")
            {
                return mFractal.TimeSpentOut;
            }
            if (comboBoxSelectDisplayMethod.Text == "Time-Spent Inside")
            {
                return mFractal.TimeSpentIn;
            }
            
            return null;
        }

        private void buttonSaveNumericImage_Click(object sender, EventArgs e)
        {

            saveFileNumericImage.Filter = "Rakabrot Numeric Image(*.rni)|*.rni|All(*.*)|*.*";
            saveFileNumericImage.FilterIndex = 1;
            saveFileNumericImage.FileName = comboBoxSelectDisplayMethod.Text;

            if (saveFileNumericImage.ShowDialog() == DialogResult.OK)
            {

                GetActiveNumericImage().SaveDataToFile(saveFileNumericImage.FileName);

            }

        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void buttonSaveBitmap_Click(object sender, EventArgs e)
        {

            saveFileImage.Filter = "Bmp|*.BMP|Jpg|*.JPG|Gif|*.GIF";

            saveFileImage.FilterIndex = 1;
            saveFileImage.FileName = comboBoxSelectDisplayMethod.Text;
            

            if (saveFileImage.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    GetActiveNumericImage().SaveBitMap(saveFileImage.FileName);
                }catch{
                }

            }
        }

       
        private void comboBoxSelectDisplayMethod_SelectedIndexChanged(object sender, EventArgs e)
        {
            

        }

      
    }
}
