using System;
using System.Collections.Generic;
using System.IO;
using RakabrotPluginInterface.RMath;

using System.Text;

using RakabrotPluginInterface;
namespace CRFractal 
{

    public class RFractalFormulaPowerEx : RFractalFormulaAbstract
    {

        int         mPower;
        protected RFractalFormulaAbstract.RInitFunction mFunction;

        public RFractalFormulaPowerEx()
        {

            Init();
        }
        void Init()
        {
            mName = "ZPowerEx";
            mFormulaString = " init: \n Z = 0  \n Loop:  \n Z =Functionm(Z)^mPower + #pixel";
            mPower = 2;
            mFunction = RInitFunction.z;
        
        }

        public RFractalFormulaPowerEx(string StartDirectory)
            : base(StartDirectory)
        {

              Init();
        }
        public override void SaveToFile(StreamWriter sw, string ExtraInfo)
        {

            base.SaveToFile(sw, ExtraInfo);

            sw.WriteLine("PowerEx");
            sw.WriteLine(mPower);


        }
        public override void LoadFromFile(StreamReader sr)
        {
            String Line;

            base.LoadFromFile(sr);

            Line = sr.ReadLine();
            Line = sr.ReadLine();

            mPower = Convert.ToInt32(Line);


        }

        public int Power
        {
            get
            {
                return mPower;
            }
            set
            {
                mPower = value;
            }
        }
        public RInitFunction Function
        {
            get
            {
                return mFunction;
            }
            set
            {
                mFunction = value;
            }
        }

        protected override void Init(Complex Z)
        {
            Z = mPixel;
        }
        protected override uint Loop(Complex Z)
        {

            mCounter = 0;
            mCalcPath.Clear();
            Complex TempZ2;
            Complex TempZ1;

            TempZ2 = InitZ(mPixel);
            while (true)
            {
           //     for (int j = 1; j < mA; j++)
            //        TempZ1 = Z * TempZ1;
                TempZ1 = GetFuncValue(Z, mFunction);
                for (int k = 0; k < mPower; k++)
                    TempZ2 = TempZ2 * TempZ1;

                Z = TempZ2 + mPixel;
                mCounter++;
                if (mCalculationInfo.BuddhabrotInside || mCalculationInfo.BuddhabrotOutside ||
                    mCalculationInfo.CalculationPathInside || mCalculationInfo.CalculationPathOutside)
                    mCalcPath.AddElement(Z);
                if (mCounter >= mMaxIterations)
                {
                    return mCounter;
                }
                if (CheckBailout(Z))
                {
                    return mCounter;
                }
                TempZ2 = Z;
            }

        }

    }
}
