using System;
using System.Collections.Generic;
using System.IO;
using RakabrotPluginInterface.RMath;

using System.Text;
using RakabrotPluginInterface;
using RakabrotPluginInterface.RCommon;

namespace CRFractal 
{

    public class RFractalFormulaSum : RakabrotPluginInterface.RFractalFormulaAbstract
    {

        int mPower1;
        int mPower2;
        protected RFractalFormulaAbstract.RInitFunction mFunction;

        public RFractalFormulaSum()
        {
            // 
            // TODO: Add constructor logic here
            //
         }
         void Init()
        {
            mName = "Sum";
            mFormulaString = " init: \n Z = 0  \n Loop:  \n Z =Functionm(Z)^mPower1 +Functionm(Z)^mPower2 + #pixel\n |Power1|<|Power2|";
            mPower1 = 3;
            mPower2 = 4;
            mFunction = RInitFunction.z;
        }

        public RFractalFormulaSum(string StartDirectory)
            : base(StartDirectory)
        {

              Init();
        }
        public override void SaveToFile(StreamWriter sw, string ExtraInfo)
        {

            base.SaveToFile(sw, ExtraInfo);

            sw.WriteLine("PowerEx");
            sw.WriteLine(mPower1);
            sw.WriteLine(mPower2);


        }
        public override void LoadFromFile(StreamReader sr)
        {
            String Line;

            base.LoadFromFile(sr);

            Line = sr.ReadLine();
            Line = sr.ReadLine();

            mPower1 = Convert.ToInt32(Line);
            mPower2 = Convert.ToInt32(Line);


        }

        public int Power1
        {
            get
            {
                return mPower1;
            }
            set
            {
                mPower1 = value;
            }
        }
        public int Power2
        {
            get
            {
                return mPower2;
            }
            set
            {
                mPower2 = value;
            }
        }
        public RFractalFormulaAbstract.RInitFunction Function
        {
            get
            {
                return mFunction;
            }
            set
            {
                mFunction = value;
            }
        }
        
        protected override void Init(Complex Z)
        {
            Z = mPixel;
        }
        protected override uint Loop(Complex Z)
        {

            mCounter = 0;
            mCalcPath.Clear();
            Complex TempZ2;
            Complex TempZ1;
            Complex FinZ1;
            Complex FinZ2;
            Complex One ;
            int Loop1Power = Math.Abs(Power1);
            int Loop2Power = Math.Abs(Power2) - Loop1Power;

            One.Real = 1;
            One.Imag = 0;
            TempZ2 = InitZ(mPixel);
            while (true)
            {
           //     for (int j = 1; j < mA; j++)
                //        TempZ1 = Z * TempZ1;
                TempZ1 = GetFuncValue(TempZ2, Function);
                for (int k = 0; k < Loop1Power; k++)
                    TempZ2 = TempZ2 * TempZ1;
                if (Power1 < 0) FinZ1 = One / TempZ2;
                else FinZ1 = TempZ2;

                for (int k = 0; k < Loop2Power; k++)
                    TempZ2 = TempZ2 * TempZ1;

                if (Power2 < 0) FinZ2 = One / TempZ2;
                else FinZ2 = TempZ2;

                Z = FinZ1 + FinZ2 + mPixel;
                mCounter++;
                if (mCalculationInfo.BuddhabrotInside || mCalculationInfo.BuddhabrotOutside ||
                    mCalculationInfo.CalculationPathInside || mCalculationInfo.CalculationPathOutside)
                    mCalcPath.AddElement(Z);
                if (mCounter >= mMaxIterations)
                {
                    return mCounter;
                }
                if (CheckBailout(Z))
                {
                    return mCounter;
                }
                TempZ2 = Z;
            }
        
        }
        
    }
}
