using System;
using System.IO;
using RakabrotPluginInterface.RMath;

using RakabrotPluginInterface;
namespace CRFractal
{
	/// <summary>
	/// 
	/// </summary>
    public class RFractalFormulaZPower : RakabrotPluginInterface.RFractalFormulaAbstract
	{

		int			mPower;
		public RFractalFormulaZPower()
		{
			// 
			// TODO: Add constructor logic here
			//

            Init();
		}

        void Init()
        {
			mName = "ZPower";
			mFormulaString = " init: \n Z = 0  \n Loop:  \n Z = Z^{Power} + #pixel";
            mPower         = 2 ;  
        }
        public RFractalFormulaZPower(string StartDirectory)
            : base(StartDirectory)
        {
            // 
            // TODO: Add constructor logic here
            //

              Init();
        }

		public override  void SaveToFile(StreamWriter sw, string ExtraInfo)
		{
	
			base.SaveToFile(sw,ExtraInfo);

			sw.WriteLine("Power");
			sw.WriteLine(mPower);

				
		}
		public override void LoadFromFile(StreamReader sr)
		{
			String		Line;	
			
			base.LoadFromFile(sr);

			Line = sr.ReadLine();
			Line = sr.ReadLine();

			mPower = Convert.ToInt32(Line);

		
		}

		public int Power
		{
			get
			{
				return mPower;
			}
			set
			{
				mPower  = value;
			}
		}

		protected  override void Init(Complex Z)
		{
			Z = mPixel;
		}
		protected  override uint Loop(Complex Z)
		{	
			
			mCounter = 0;
			mCalcPath.Clear();
            Complex TempZ2;


            while (true)
            {

                TempZ2 = InitZ(mPixel);
                for (int k = 0; k < mPower; k++)
                  TempZ2 = TempZ2 * Z;

                Z = TempZ2 + Pixel();
				mCounter++;
                if (mCalculationInfo.BuddhabrotInside || mCalculationInfo.BuddhabrotOutside ||
                    mCalculationInfo.CalculationPathInside || mCalculationInfo.CalculationPathOutside)
                    mCalcPath.AddElement(Z);
				if(mCounter >= mMaxIterations) 
				{
					return mCounter;
				}
				if( CheckBailout(Z))
				{
					return mCounter;
				}

			}

		}

	}
}
