using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using CRFractal;
using RakabrotPluginInterface.RNumericImage;
using RakabrotPluginInterface.RCommon;
//using RNGradient;
using RImageTexture;

namespace RNumericImage{

    class RNumericImageTexture : RNumericImageAbstract
    {
        RTextureHolder mHolder;
        RTexture Test; 

        public RNumericImageTexture()
		{
	    }
        public override bool  GetChange()
        {
            return true;
        }
        public RNumericImageTexture(int nWidth, int nHeight)
            : base(nWidth, nHeight)
            
		{

            
            
        }
        public RNumericImageTexture(RGrid nGrid)
            : base(nGrid)
        {
        }
       /* public RNumericImageTexture(RGrid nGrid, RGradient nGradient)
            : base(nGrid, nGradient)
        {
        }        
        */

        public override void CalcBitmap()
        {
            mBitmap = new Bitmap(mGrid.Width,
                mGrid.Height, System.Drawing.Imaging.PixelFormat.Format24bppRgb);

            int bytes = mGrid.Width * mGrid.Height * 3;
            byte[] rgbValues = new byte[bytes];

//            Test = new RTexture("D:\\Fraktali\\texture\\Test.jpg");
            mHolder = new RTextureHolder();
 
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\1.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\2.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\3.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\4.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\5.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\6.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\7.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\8.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\9.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\10.jpg");
            mHolder.AddTextureFile("D:\\Fraktali\\texture\\11.jpg");


            Rectangle rect = new Rectangle(0, 0, mGrid.Width, mGrid.Height);
            System.Drawing.Imaging.BitmapData bmpData =
                   mBitmap.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadWrite,
                   mBitmap.PixelFormat);

            IntPtr ptr = bmpData.Scan0;

            uint CurrentIndex = 0;
            uint CurrentIndexRGB = 0;

            System.Drawing.Color tColor;

            for (int i = 0; i < mGrid.Height; i++)
                for (int j = 0; j < mGrid.Width; j++)
                {
                    //                    tColor = mGradient.GetColor();
              //      = mGradient.GetColor(mHolder);

//                    tColor = System.Drawing.Color.Aqua;
                    
//                    if (mData[CurrentIndex] < 10)
//                            tColor = Test.GetPixel(i, j);
                               tColor = mHolder.GetColor(i, j, ((uint)mData[CurrentIndex]) % 11);

                    rgbValues[CurrentIndexRGB + 2] = tColor.R;
                    rgbValues[CurrentIndexRGB + 1] = tColor.G;
                    rgbValues[CurrentIndexRGB] = tColor.B;
                    CurrentIndex++;
                    CurrentIndexRGB += 3;
                }

            freshBitmap = true;
            System.Runtime.InteropServices.Marshal.Copy(rgbValues, 0, ptr, bytes);
            mBitmap.UnlockBits(bmpData);
        }

        public virtual void DrawImage(Graphics g)
        {

            if (!IsBitmapFresh())
            {
                CalcBitmap();
            }
            g.DrawImage(
                mBitmap,
                0,
                0,
                mBitmap.Width,
                mBitmap.Height);

        }

        public override void LoadDataFromFile(string FileName)
        {
 
        }


    }


}
