using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Reflection;
using System.Runtime.Remoting;

using RakabrotPluginInterface;

namespace Rakabrot
{
    public class RakabrotPlugin{

        public string                            mName;
        public RakabrotPluginInterface.IPluginInfo  mInterface;
        public RakabrotPlugin(string nName, RakabrotPluginInterface.IPluginInfo nInterface) 
        {
            mName = nName;
            mInterface = nInterface;
        }
    }

    public class RakabrotPluginPluginHolder
    {
        int                       mMaxIndex;

        public int MaxIndex{
            get { return mMaxIndex; }
    }
        RakabrotPlugin[]              mPlugins;

        public      RakabrotPluginPluginHolder(int Size) 
        {
            mMaxIndex = 0;
            mPlugins = new RakabrotPlugin[Size];
        }

        public void LoadPluginsFromDirectory()
        {
            string startDirectory;

            startDirectory = System.IO.Directory.GetCurrentDirectory();
            LoadPluginsFromDirectory(startDirectory);


        }
        public string GetName(int index) 
        {
            return mPlugins[index].mName;
        }
        public void LoadPluginsFromDirectory(string Directory)
        {
            string startDirectory;
            string pluginDirectory;
            string tempName;

            startDirectory = System.IO.Directory.GetCurrentDirectory();

            pluginDirectory = Directory + "\\Plugins";

            System.IO.Directory.SetCurrentDirectory(pluginDirectory);

            DirectoryInfo di = new DirectoryInfo(pluginDirectory);
            FileInfo[] rgFiles = di.GetFiles("Rakabrot*Plugin.Dll");

            ObjectHandle oHandle;


            foreach (FileInfo fi in rgFiles)
            {
                tempName = fi.Name;
//                tempName.Replace(".DLL", "");
//                tempName.Replace(".dll", "");
                tempName = tempName.Remove(tempName.Length - 4);
                oHandle = Activator.CreateInstanceFrom
               (fi.Name,
                tempName + ".PluginInfo");
//               "fi.Name" +".PluginInfo");
//               "fi.Name" +".PluginInfo");

                IPluginInfo pluginInfo = oHandle.Unwrap() as IPluginInfo;
                AddPlugin(new RakabrotPlugin(pluginInfo.Name, pluginInfo));
                
            }

            System.IO.Directory.SetCurrentDirectory(startDirectory);

        }
        public void AddPlugin(RakabrotPlugin nPlugin) 
        {
            if (MaxIndex < mPlugins.Length)
            {
                mPlugins[MaxIndex] = nPlugin;
                mMaxIndex++;

            }
            else 
            { 
//                mPlugins.
            }
        }
        
        public RakabrotPluginInterface.RFractalFormulaAbstract  GetFormula(int Index) 
        {
            return mPlugins[Index].mInterface.GetFormula();
        }

        public RakabrotPluginInterface.RFractalFormulaAbstract GetFormula(string PluginName) 
        {
            for (int i = 0; i < MaxIndex; i++) 
            {
                if (PluginName == mPlugins[i].mName) 
                {
                    return mPlugins[i].mInterface.GetFormula(MainWindow.StartDirectory);
                }
            }

            return null;
        }
    }
}
